︠e41cd3e0-52e1-462f-a827-a7f69d2b6569ai︠
%hide
%auto
DATA="foo.data/"
︡f57f1418-13a8-47bf-bcb5-dc2d42ffde8d︡{"auto":true}︡
︠12e31f80-d42c-4f52-a602-79abd5887179i︠
%md
# Scheduling group presentations with Sage

[A blog post describing what I'm doing here](http://drvinceknight.blogspot.co.uk/2014/03/scheduling-group-presentations-using.html)
︡4b741ff5-9f41-4725-878e-bab9f74537a6︡{"md":"# Scheduling group presentations with Sage\n\n[A blog post describing what I'm doing here](http://drvinceknight.blogspot.co.uk/2014/03/scheduling-group-presentations-using.html)\n"}︡
︠583f6cdd-4035-4b6b-8ed2-7a4ee17d8121i︠
%md
# Reading in the data

(If you wanted to run this with the same data you would need to copy the following file to your project also: [2015-2016-availability.csv](https://cloud.sagemath.com/projects/c5be8454-3f27-4e5a-865c-590833f25333/files/2015-2016-availability.csv).)
︡c6369aaf-fefe-4560-a7cb-a879f32c759d︡︡{"done":true,"md":"# Reading in the data\n\n(If you wanted to run this with the same data you would need to copy the following file to your project also: [2015-2016-availability.csv](https://cloud.sagemath.com/projects/c5be8454-3f27-4e5a-865c-590833f25333/files/2015-2016-availability.csv).)"}
︠72e41d9b-c052-4baf-8eb7-71eecf535a56s︠
import csv
f=open('2015-2016-availability.csv','r')
raw_data = [row for row in csv.reader(f)]
f.close()
︡3e448149-90ee-4c29-ada3-fe15eacde8fb︡︡{"done":true}
︠7b71700f-c506-4799-8413-6f67d2fe910di︠
%md
# Grabbing the company names
︡041df658-243e-497a-9f3f-af6da5e57f9c︡{"md":"# Grabbing the company names\n"}︡
︠03242a5b-c13b-4052-8cc4-bf04f1e8fe2ds︠
companylabels = [row[0] for row in raw_data[1:]]
companylabels
︡265b6086-0cba-47e4-8d5f-325fc2c17e26︡︡{"stdout":"['Whetstone Industries', 'Instant', 'Cardiff Calculus Crew', 'MathsFC.co.uk', 'Efficient', 'Alpha(2)', 'Compitance with a capital Q', 'Ambrosia', 'Ridgway Ltd.', 'Delta', 'Honeybadger', 'The Squadratics', 'PiMaticians', 'Easy Alpha Mathematics', 'Enwaduron', 'Prime co.', 'Pixel', 'Mathletico Madrid', 'Tech.ED', 'Mathemagicians', 'Bearded Muffins', 'Panda and Co', 'QED Solutions', 'Timekeeper', 'Awesome Arithmetic', 'SOUVLAKI', 'Alpha(1)', 'The Encyclopaedophiles', 'CompConnect', 'E=MCHammer', 'ATAK', 'Mathematician Masters', 'HANJ Developments', 'Supremum', 'BudgEat']\n"}︡{"done":true}
︠e14409c5-263d-44c7-9cf2-eadbe1f431eci︠
%md
Checking that have correct amount
︡b127a5ec-a07a-49e0-ad0c-f1e43ee85847︡{"md":"Checking that have correct amount\n"}︡
︠005c605d-dfdb-4096-946b-701505f4b956s︠
len(companylabels)
︡161bf43a-f6cf-4442-99ef-6a2369db1730︡︡{"stdout":"35\n"}︡{"done":true}
︠40ca0a88-d9f8-4896-b7db-f137c890c997i︠
%md
# Grabbing the schedule labels
︡953d54f0-c4cd-4b1d-8aa5-2c2fe603cbb9︡{"md":"# Grabbing the schedule labels\n"}︡
︠e968822a-e222-4ff7-821d-d88d051c3f4fs︠
schedulelabels = [s.strip() for s in raw_data[0][1:]]
schedulelabels
len(schedulelabels)

︡0469bc86-52cc-4047-afe5-a36743b2322b︡︡{"stdout":"['MON0900', 'MON0930', 'MON1000', 'MON1030', 'MON1100', 'MON1130', 'MON1200', 'MON1230', 'MON1300', 'MON1330', 'MON1400', 'MON1430', 'MON1500', 'MON1530', 'MON1600', 'MON1630', 'MON1700', 'MON1730', 'TUE0900', 'TUE0930', 'TUE1000', 'TUE1030', 'TUE1100', 'TUE1130', 'TUE1200', 'TUE1230', 'TUE1300', 'TUE1330', 'TUE1400', 'TUE1430', 'TUE1500', 'TUE1530', 'TUE1600', 'TUE1630', 'TUE1700', 'TUE1730', 'THU0900', 'THU0930', 'THU1200', 'THU1230', 'THU1300', 'THU1330', 'THU1400', 'THU1430', 'THU1500', 'THU1530', 'THU1600', 'THU1630', 'THU1700', 'THU1730', 'FRI1000', 'FRI1030', 'FRI1100', 'FRI1130', 'FRI1200', 'FRI1230', 'FRI1300', 'FRI1330', 'FRI1400', 'FRI1430', 'FRI1500', 'FRI1530', 'FRI1600', 'FRI1630', 'FRI1700', 'FRI1730']\n"}︡{"stdout":"66\n"}︡{"done":true}
︠80d871d0-8ea2-48fd-85bc-63b570ca20dei︠
%md
# Cleaning the data from doodle
︡a1091eb1-01e9-4933-b36d-e6286da35462︡{"md":"# Cleaning the data from doodle\n"}︡
︠129ef01b-7e2b-48c6-ae13-b6ae977ad925︠
def clean(l):
    if l == '':
        return 0
    return 1
data = [[clean(l) for l in row[1:]] for row in raw_data[1:]]
︡cc0926eb-4718-4095-bb8b-46b2a8e64a76︡︡{"done":true}
︠901c5b6a-ff58-4da5-8875-42207fc3a86bi︠
%md
# Double checking that have not lost any data
︡0a9d5daf-e2c0-4a90-af23-0a67371262d1︡{"md":"# Double checking that have not lost any data\n"}︡
︠0088d974-e3b9-44e4-a4fb-f19426ef9801s︠
M = matrix(data) # Converting data to a matrix
M.dimensions() == (len(companylabels), len(schedulelabels))
︡8d56a2fe-f2d5-418b-9c98-77b396639ac6︡︡{"stdout":"False\n"}︡{"done":true}
︠0cff60d8-0286-45d1-aa95-c883a7946b9ai︠
%md
# Removing schedule slots with no entries
︡a36429eb-b88c-4103-bfaa-bf42393306bd︡{"md":"# Removing schedule slots with no entries\n"}︡
︠6a48c427-a853-4568-8466-b6016709135es︠

︡4b20ce39-b2b5-4150-9131-a3dcba26d49d︡︡{"done":true}
︠65f85683-7808-4a54-a16d-1d064cc9a0c9s︠
indices = [i for i, x in enumerate([max(row) for row in M.transpose()]) if x == 0]
schedulelabels = [s for i,s in enumerate(schedulelabels) if i not in indices]
len(schedulelabels)


︡798630d5-00dc-47f6-acfe-56a9d0a21919︡︡{"stdout":"57\n"}︡{"done":true}
︠4283fbc7-921c-4dee-97f3-51eb890a19c3i︠
%md
# Plotting the graph that defines our problem
︡64c774c9-2369-4dce-a3a8-70d36d85d4af︡{"md":"# Plotting the graph that defines our problem\n"}︡
︠96c2464a-d737-4c1a-94a2-3c7e3cfc5e5as︠
M = matrix([row for row in M.transpose() if max(row) != 0]).transpose() # Removing unconnected time slots (removing columns with 0 values)
g= BipartiteGraph(M) # Creating a graph
p = g.coloring()  # Obtaining a coloring of the graph (as graph is bi partite this gets companies in one colour and slots in another
g.show(layout='circular',dist=1,vertex_size=250, graph_border=True, figsize=[15,15],partition=p,svg=False) # Draw the graph
︡b5a3f8b9-49fd-4087-8b37-ff832878596f︡︡{"file":{"filename":"/projects/c5be8454-3f27-4e5a-865c-590833f25333/.sage/temp/compute3-us/2525/tmp_ilN0is.png","show":true,"text":null,"uuid":"69b880c5-eb8f-4a30-94d7-b29b1b15e409"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠432c8d85-70cb-4a87-ad47-0b8ced64a3fbi︠
%md
# Solve the problem

Solve the maximum matching algorithm associated with our bi-partite graph (in essence this pairs schedules and companies in such a way as to maximise the number of pairings). Code lifted from Sage documentation: http://www.sagemath.org/doc/thematic_tutorials/linear_programming.html#matching

︡5a89f853-09fc-4e78-8d6e-578d6b81a4c5︡{"md":"# Solve the problem\n\nSolve the maximum matching algorithm associated with our bi-partite graph (in essence this pairs schedules and companies in such a way as to maximise the number of pairings). Code lifted from Sage documentation: http://www.sagemath.org/doc/thematic_tutorials/linear_programming.html#matching\n\n"}︡
︠27b2d351-0111-4e03-9d2e-38a9a955e824s︠
p = MixedIntegerLinearProgram()
matching = p.new_variable(binary=True)
p.set_objective(sum(matching[e] for e in g.edges(labels=False)))
for v in g:
      p.add_constraint(sum(matching[e]
          for e in g.edges_incident(v, labels=False)) <= 1)
p.solve()
matching = p.get_values(matching)
schedule = [e for e,b in matching.iteritems() if b == 1]
︡9f9bbabc-a00e-48bd-8a30-f4328b61464d︡︡{"stdout":"34.0\n"}︡{"done":true}
︠d9659142-52ec-4e0a-b94b-2c5d09d21c2ai︠
%md
# Plotting the solution to our problem
︡31e3d29d-d6e9-4c64-a4bf-26c33b1146a0︡{"md":"# Plotting the solution to our problem\n"}︡
︠5b3aa808-d1a3-4b5a-a06a-935fe36ebd88s︠
B=Graph(schedule)
p = B.coloring()
B.show(layout='circular',dist=1,vertex_size=250, graph_border=True, figsize=[15,15],partition=p,svg=False)
︡8606ad5d-1b61-42fb-aa40-4e70a43e00f4︡︡{"file":{"filename":"/projects/c5be8454-3f27-4e5a-865c-590833f25333/.sage/temp/compute3-us/2525/tmp_FNRj42.png","show":true,"text":null,"uuid":"030f51da-81ae-408a-abce-cb6e595ae3b1"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠ad89065f-12eb-439c-885c-74bef9c5b2bei︠
%md

# Viewing the schedule
︡296349e8-381e-4410-b61d-a0ab8ef82e4d︡{"md":"\n# Viewing the schedule\n"}︡
︠30433b1b-88ec-46b2-92be-92b918827adas︠
schedule = sorted([sorted(s) for s in schedule])
schedule  # Printing out the schedule in 'unfriendly' form
︡15b4a5f4-059a-4843-89a0-caca5617e06f︡︡{"stdout":"[[4, 78], [5, 74], [13, 57], [14, 59], [17, 60], [18, 72], [20, 65], [21, 71], [23, 67], [24, 68], [25, 58], [26, 70], [29, 75], [30, 77], [32, 80], [33, 66], [34, 84], [36, 69], [38, 63], [40, 79], [41, 85], [42, 86], [43, 62], [44, 73], [46, 61], [48, 64], [49, 76], [50, 83], [51, 81], [52, 87], [53, 88], [54, 82], [55, 89], [56, 90]]\n"}︡{"done":true}
︠dfe07671-053a-49c1-8aaf-bc3476c413f5︠
︡886a0648-65b7-4074-888c-ecabb05128a9︡
︠2dcc6552-fb08-4a7a-b78a-dbebc428f10es︠
# Printing it out in a more readable way
for s in sorted([companylabels[s[1] - len(schedulelabels)]+ ": " + schedulelabels[(s[0])]  for s in schedule]):
    print s
︡fc7f7df7-05d6-4cdb-ac89-db7bfcc81e8d︡︡{"stdout":"ATAK: FRI1530\nAlpha(1): FRI1430\nAlpha(2): FRI1100\nAmbrosia: FRI1330\nAwesome Arithmetic: FRI1500\nBearded Muffins: THU1230\nCardiff Calculus Crew: TUE1000\nCompConnect: FRI1000\nCompitance with a capital Q: THU1630\nDelta: THU1400\nE=MCHammer: FRI1030\nEasy Alpha Mathematics: TUE1730\nEfficient: FRI1230\nEnwaduron: TUE1400\nHANJ Developments: FRI1700\nHoneybadger: TUE1500\nInstant: TUE1700\nMathemagicians: FRI1400\nMathematician Masters: FRI1600\nMathletico Madrid: MON1330\nMathsFC.co.uk: TUE1130\nPanda and Co: MON1300\nPiMaticians: THU1530\nPixel: FRI1130\nPrime co.: TUE1230\nQED Solutions: THU1730\nRidgway Ltd.: TUE1330\nSOUVLAKI: FRI1630\nSupremum: FRI1730\nTech.ED: THU1200\nThe Encyclopaedophiles: THU1430\nThe Squadratics: TUE1530\nTimekeeper: THU1330\nWhetstone Industries: MON1730\n"}︡{"done":true}
︠410ec283-2dd7-40c0-b946-a3f433ec562fs︠
# Printing it out in a more readable way
for s in sorted([schedulelabels[(s[0])] + ": " + companylabels[s[1] - len(schedulelabels)]  for s in schedule]):
    print s
︡7f02591a-96e5-4b2a-bc09-b847698d79a6︡︡{"stdout":"FRI1000: CompConnect\nFRI1030: E=MCHammer\nFRI1100: Alpha(2)\nFRI1130: Pixel\nFRI1230: Efficient\nFRI1330: Ambrosia\nFRI1400: Mathemagicians\nFRI1430: Alpha(1)\nFRI1500: Awesome Arithmetic\nFRI1530: ATAK\nFRI1600: Mathematician Masters\nFRI1630: SOUVLAKI\nFRI1700: HANJ Developments\nFRI1730: Supremum\nMON1300: Panda and Co\nMON1330: Mathletico Madrid\nMON1730: Whetstone Industries\nTHU1200: Tech.ED\nTHU1230: Bearded Muffins\nTHU1330: Timekeeper\nTHU1400: Delta\nTHU1430: The Encyclopaedophiles\nTHU1530: PiMaticians\nTHU1630: Compitance with a capital Q\nTHU1730: QED Solutions\nTUE1000: Cardiff Calculus Crew\nTUE1130: MathsFC.co.uk\nTUE1230: Prime co.\nTUE1330: Ridgway Ltd.\nTUE1400: Enwaduron\nTUE1500: Honeybadger\nTUE1530: The Squadratics\nTUE1700: Instant\nTUE1730: Easy Alpha Mathematics\n"}︡{"done":true}
︠148d40b1-05c0-48a8-9be6-b6eb7bdb7f91︠











